#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <dir.h>

#define MAX_ARRAY 300
struct ffblk files[ MAX_ARRAY ];

FILE *out;
char *pre, *href, *t, *post;

int ccmp( const void *a, const void *b)
{
   return stricmp( ((struct ffblk *)a)->ff_name,
		   ((struct ffblk *)b)->ff_name );
}

char *months[]= {
	"jan", "feb", "mar", "apr", "may", "jun",
	"jul", "aug", "sep", "oct", "nov", "dec" };

void main(int argc, char *argv[] )
{
   struct ffblk ffblk;
   int i, j, done;

   if (argc<2)
   {
      printf("TATDIR ver. %s\nᯮ짮: %s out_file.htm [/]\n",
      __DATE__, argv[0] );
      printf("\t:\t /s 뢠 ࠧ 䠩\n\t"\
	     "\t /n ஢  \n\t\t /h ந  A HREF=\n");
      exit(1);
   }

   if ((out=fopen(argv[1], "wt"))==NULL)
   {
      printf("%s:   '%s'\n", argv[0], argv[1] );
      exit(1);
   }

   fprintf(out, "<HTML><BODY>\n<TABLE BORDER=2 WIDTH=\"100%%\">\n");
   done = findfirst("*.*",&ffblk,0);
   i=0;
   while (!done && i< MAX_ARRAY)
   {
      printf("  %s\n", ffblk.ff_name);
      memcpy( &files[i++], &ffblk, sizeof(ffblk));
      done = findnext(&ffblk);
   }

   if (argc>2 && strchr(argv[2], 'n') && i>0)
   {
      qsort( files, i, sizeof(ffblk), ccmp );
   }

   for ( j=0; j<i; j++ )
   {
      union { struct { unsigned d:5, m:4, y:7; } d;
	      int dt;
	    } x;

      x.dt = files[j].ff_fdate;

      if (argc>2 && strchr(argv[2], 'h'))
      {
	 pre  = "<A HREF=\"";
	 href = files[j].ff_name;
	 t    = "\">";
	 post = "</A>";
      }
      else
      {
	 pre  = "";
	 href = "";
	 t    = "";
	 post = "";
      }
      fprintf(out, "<TR><TD>%s%s%s%s%s</TD>",
		   pre, href, t, files[j].ff_name, post );
      fprintf(out, "<TD ALIGN=RIGHT>%lu kb</TD>",
		   files[j].ff_fsize / 1024L );
      fprintf(out, "<TD ALIGN=RIGHT>%u %s %u</TD><TD>...</TD></TR>\n",
	      x.d.d, months[x.d.m-1], x.d.y + 1980 );
   }
   fprintf(out, "</TABLE>\n</BODY></HTML>");
   fclose(out);
   exit(0);
}
